package gregapi.render;

import static gregapi.data.CS.T;
import gregapi.util.ST;
import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.client.renderer.entity.RenderItem;
import net.minecraft.client.renderer.texture.TextureManager;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.minecraft.util.ResourceLocation;

import org.lwjgl.opengl.GL11;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class RenderHelper {
	public static RenderItem   mRenderItem   = new RenderItem();
	public static RenderBlocks mRenderBlocks = new RenderBlocks();
	
	public static void renderItemIntoGUI(FontRenderer aFontRenderer, TextureManager aTextureManager, ItemStack aStack, int aX, int aY, boolean aEffect) {
		if (aStack.getItemSpriteNumber() == 0 && RenderBlocks.renderItemIn3d(Block.getBlockFromItem(aStack.getItem()).getRenderType())) {
			aTextureManager.bindTexture(TextureMap.locationBlocksTexture);
			Block block = Block.getBlockFromItem(aStack.getItem());
			GL11.glEnable(GL11.GL_ALPHA_TEST);
			if (block.getRenderBlockPass() != 0) {
				GL11.glAlphaFunc(GL11.GL_GREATER, 0.1F);
				GL11.glEnable(GL11.GL_BLEND);
				OpenGlHelper.glBlendFunc(770, 771, 1, 0);
			} else {
				GL11.glAlphaFunc(GL11.GL_GREATER, 0.5F);
				GL11.glDisable(GL11.GL_BLEND);
			}
			GL11.glPushMatrix();
			GL11.glTranslatef(aX-2, aY+3, mRenderItem.zLevel-3);
			GL11.glScalef(10.0F, 10.0F, 10.0F);
			GL11.glTranslatef(1.0F, 0.5F, 1.0F);
			GL11.glScalef(1.0F, 1.0F, -1.0F);
			GL11.glRotatef(210.0F, 1.0F, 0.0F, 0.0F);
			GL11.glRotatef(45.0F, 0.0F, 1.0F, 0.0F);
			int tColor = aStack.getItem().getColorFromItemStack(aStack, 0);
			GL11.glColor4f((tColor >> 16 & 255) / 255F, (tColor >> 8 & 255) / 255F, (tColor & 255) / 255F, 1);
			GL11.glRotatef(-90.0F, 0.0F, 1.0F, 0.0F);
			mRenderBlocks.useInventoryTint = T;
			mRenderBlocks.renderBlockAsItem(block, ST.meta(aStack), 1.0F);
			mRenderBlocks.useInventoryTint = T;
			if (block.getRenderBlockPass() == 0) GL11.glAlphaFunc(GL11.GL_GREATER, 0.1F);
			GL11.glPopMatrix();
		} else {
			GL11.glAlphaFunc(GL11.GL_GREATER, 0.1F);
			ResourceLocation tResource = aTextureManager.getResourceLocation(aStack.getItemSpriteNumber());
			int tMaxRenderPasses = Math.max(1, aStack.getItem().getRenderPasses(ST.meta(aStack)));
			for (int i = 0; i < tMaxRenderPasses; i++) {
				IIcon tIcon = aStack.getItem().getIcon(aStack, i);
				if (tIcon == null) tIcon = ((TextureMap)Minecraft.getMinecraft().getTextureManager().getTexture(tResource)).getAtlasSprite("missingno");
				GL11.glDisable(GL11.GL_LIGHTING);
				GL11.glEnable (GL11.GL_BLEND);
				OpenGlHelper.glBlendFunc(770, 771, 1, 0);
				aTextureManager.bindTexture(tResource);
				int tColor = aStack.getItem().getColorFromItemStack(aStack, i);
				GL11.glColor4f((tColor >> 16 & 255) / 255F, (tColor >> 8 & 255) / 255F, (tColor & 255) / 255F, 1);
				GL11.glDisable(GL11.GL_LIGHTING);
				GL11.glEnable (GL11.GL_ALPHA_TEST);
				
				mRenderItem.renderIcon(aX, aY, tIcon, 16, 16);
				
				GL11.glDisable(GL11.GL_BLEND);
				GL11.glEnable (GL11.GL_LIGHTING);
				GL11.glDisable(GL11.GL_ALPHA_TEST);
				if (aEffect && aStack.hasEffect(i)) mRenderItem.renderEffect(aTextureManager, aX, aY);
				GL11.glEnable(GL11.GL_LIGHTING);
			}
		}
		GL11.glEnable(GL11.GL_CULL_FACE);
	}
}